/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.person.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="BERUF.UK",
     query="SELECT o FROM Beruf o WHERE "

                         + "o"
                +".name"
              +" = ?1"

     ,
   hints = {
              @javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="BERUF.All",
     query="SELECT obj FROM Beruf obj",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="BERUF.Count",
     query="SELECT COUNT(obj) FROM Beruf obj",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "BERUF")
// @javax.persistence.IdClass(BerufPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class Beruf
extends AbstractBeruf
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public Beruf() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Beruf(Beruf original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "beruf_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Beruf")
    @javax.persistence.TableGenerator(name = "Beruf", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Beruf", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient BerufPK pkCache;

  @Override
  public BerufPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new BerufPK(getId());
    }

    return pkCache;
  }

  public static <E extends Beruf> java.util.Map<BerufPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<BerufPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Beruf> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;


  public void resetAttributeChanged() {
        hasChangedCode = false;
          hasChangedGeschlecht = false;
          hasChangedHerkunft = false;
          hasChangedName = false;
  



    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Column(name = "CODE", nullable = BerufConstants.CODE_NULLABLE, length=BerufConstants.CODE_MAX_LENGTH)
        
  protected java.lang.String code =  null;

  @javax.persistence.Transient
  protected boolean hasChangedCode = false;

  public boolean hasChangedCode(){
    return hasChangedCode;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertCode = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenCode;
  
  /**
   * 
   *
   * getter for BERUF.CODE
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getCode() {
        return code;
      }

  /**
   * 
   *
   * setter for BERUF.CODE
   *
   * @param code
   */
  @Override   public void setCode(@javax.annotation.Nullable  java.lang.String code) {

       resetTkCache();
                  
                          java.lang.String codeInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(code, BerufConstants.CODE_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.code
      , codeInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedCode |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("code");
      }


             if (!isSeitLadenVeraendertCode) {
          isSeitLadenVeraendertCode = thisAttributChanged;
         if (isSeitLadenVeraendertCode){
           wertNachLadenCode=this.code;
         }
       }
      

       this.code = codeInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "GESCHLECHT", nullable = BerufConstants.GESCHLECHT_NULLABLE)
    
  protected de.ivu.elect.business.person.entity.Geschlecht geschlecht =  de.ivu.elect.business.person.entity.Geschlecht.UNBEKANNT;

  @javax.persistence.Transient
  protected boolean hasChangedGeschlecht = false;

  public boolean hasChangedGeschlecht(){
    return hasChangedGeschlecht;
  }
  
  /**
   * 
   *
   * getter for BERUF.GESCHLECHT
   */
    @Override   public  de.ivu.elect.business.person.entity.Geschlecht getGeschlecht() {
        return geschlecht;
      }

  /**
   * 
   *
   * setter for BERUF.GESCHLECHT
   *
   * @param geschlecht
   */
  @Override   public void setGeschlecht( de.ivu.elect.business.person.entity.Geschlecht geschlecht) {

       resetTkCache();
                  de.ivu.elect.business.person.entity.Geschlecht geschlechtInternal = geschlecht;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.geschlecht
      , geschlechtInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedGeschlecht |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("geschlecht");
      }


      

       this.geschlecht = geschlechtInternal;

         }

        
  @javax.persistence.Column(name = "HERKUNFT", nullable = BerufConstants.HERKUNFT_NULLABLE, length=BerufConstants.HERKUNFT_MAX_LENGTH)
        
  protected java.lang.String herkunft =  null;

  @javax.persistence.Transient
  protected boolean hasChangedHerkunft = false;

  public boolean hasChangedHerkunft(){
    return hasChangedHerkunft;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertHerkunft = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenHerkunft;
  
  /**
   * 
   *
   * getter for BERUF.HERKUNFT
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getHerkunft() {
        return herkunft;
      }

  /**
   * 
   *
   * setter for BERUF.HERKUNFT
   *
   * @param herkunft
   */
  @Override   public void setHerkunft(@javax.annotation.Nullable  java.lang.String herkunft) {

       resetTkCache();
                  
                          java.lang.String herkunftInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(herkunft, BerufConstants.HERKUNFT_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.herkunft
      , herkunftInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedHerkunft |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("herkunft");
      }


             if (!isSeitLadenVeraendertHerkunft) {
          isSeitLadenVeraendertHerkunft = thisAttributChanged;
         if (isSeitLadenVeraendertHerkunft){
           wertNachLadenHerkunft=this.herkunft;
         }
       }
      

       this.herkunft = herkunftInternal;

         }

        
      @javax.persistence.Column(name = "NAME", nullable = BerufConstants.NAME_NULLABLE, length=BerufConstants.NAME_MAX_LENGTH)
        
  protected java.lang.String name =  null;

  @javax.persistence.Transient
  protected boolean hasChangedName = false;

  public boolean hasChangedName(){
    return hasChangedName;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertName = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenName;
  
  /**
   * 
   *
   * getter for BERUF.NAME
   */
    @Override   public  java.lang.String getName() {
        return name;
      }

  /**
   * 
   *
   * setter for BERUF.NAME
   *
   * @param name
   */
  @Override   public void setName( java.lang.String name) {

       resetTkCache();
                  
                          java.lang.String nameInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(name, BerufConstants.NAME_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.name
      , nameInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedName |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("name");
      }


             if (!isSeitLadenVeraendertName) {
          isSeitLadenVeraendertName = thisAttributChanged;
         if (isSeitLadenVeraendertName){
           wertNachLadenName=this.name;
         }
       }
      

       this.name = nameInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */

/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Beruf:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Beruf other){
                             other.code = this.code;
                                other.geschlecht = this.geschlecht;
                                other.herkunft = this.herkunft;
                                other.name = this.name;
           
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Beruf.class)){
        copyEntityAttributesUsingSetter((Beruf) other.castTo(Beruf.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Beruf: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Beruf other){
               other.setCode(this.code);
                  other.setGeschlecht(this.geschlecht);
                  other.setHerkunft(this.herkunft);
                  other.setName(this.name);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Beruf other){
                       if (hasChangedCode) {
        other.setCode(this.code);
      }
                             if (hasChangedGeschlecht) {
        other.setGeschlecht(this.geschlecht);
      }
                             if (hasChangedHerkunft) {
        other.setHerkunft(this.herkunft);
      }
                             if (hasChangedName) {
        other.setName(this.name);
      }
             }





    @javax.persistence.Transient
    private transient BerufTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public BerufTK getBerufTK(){
    if (tkCache==null) {
    tkCache = new BerufTK(

getName()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getBerufTK();
    }

  @Override
  public BerufUK getUk(){
    return getBerufUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Beruf.class;
  }

public BerufUK getBerufUK(){

   return  new BerufUK(

getName()


  );
}

  @javax.persistence.Transient
  private transient BerufProperties properties;

  public BerufProperties getProperties(){
    if (properties == null) {
      properties = new BerufProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public BerufProperties getBerufProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return BerufConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(BerufConstants.MESSAGE_KEY_CODE_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(BerufConstants.MESSAGE_KEY_CODE_EINZAHL);

        code =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                    
      if (werteVorher.containsKey(BerufConstants.MESSAGE_KEY_HERKUNFT_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(BerufConstants.MESSAGE_KEY_HERKUNFT_EINZAHL);

        herkunft =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(BerufConstants.MESSAGE_KEY_NAME_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(BerufConstants.MESSAGE_KEY_NAME_EINZAHL);

        name =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertCode) {
      result.put(BerufConstants.MESSAGE_KEY_CODE_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenCode , code));
    }
                                                if (isSeitLadenVeraendertHerkunft) {
      result.put(BerufConstants.MESSAGE_KEY_HERKUNFT_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenHerkunft , herkunft));
    }
                            if (isSeitLadenVeraendertName) {
      result.put(BerufConstants.MESSAGE_KEY_NAME_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenName , name));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertCode = false;
      wertNachLadenCode = null;
                                          isSeitLadenVeraendertHerkunft = false;
      wertNachLadenHerkunft = null;
                          isSeitLadenVeraendertName = false;
      wertNachLadenName = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "BERUF";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Beruf";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

  @javax.persistence.Transient
  private transient boolean hashCodeBerechnet = false;

  @javax.persistence.Transient
  private transient int hashCode = 0;


  @Deprecated // nur in Unit-Tests verwenden(!)
  public void resetHashCode() {
    hashCodeBerechnet = false;
    hashCode = 0;
  }

  @Override
    public int hashCode() {
      if (hashCodeBerechnet) {
      return hashCode;
    }

    if (id == null) {
      hashCode = super.hashCode();
    } else {
      hashCode = id.hashCode();
    }

    hashCodeBerechnet = true;

    return hashCode;

    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(BerufConstants.CODE_MAX_LENGTH ,  code, this, BerufConstants.MESSAGE_KEY_CODE_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(geschlecht, this, BerufConstants.MESSAGE_KEY_GESCHLECHT_EINZAHL, validationResult);
                                                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(BerufConstants.HERKUNFT_MAX_LENGTH ,  herkunft, this, BerufConstants.MESSAGE_KEY_HERKUNFT_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(name, this, BerufConstants.MESSAGE_KEY_NAME_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(BerufConstants.NAME_MAX_LENGTH , 1 ,  name, this, BerufConstants.MESSAGE_KEY_NAME_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        @Override
        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }
                              }
